#include <stdio.h>
#include <stdlib.h>
#include <iostream>
using namespace std;

// решето Эратосфена 
// http://ru.wikipedia.org/wiki/%D0%E5%F8%E5%F2%EE_%DD%F0%E0%F2%EE%F1%F4%E5%ED%E0
// битовое решение

#define data_t unsigned long long
//#define data_t char

static const uint size = sizeof( data_t ) * 8;       // битов в одном слове

void set( data_t arr[], ulong pos, bool val ) {      // установить бит в битовом массиве
   ulong el = pos / size;
   data_t sh = (data_t)1 << ( pos % size );
   if( val ) arr[ el + 1 ] &= ~sh;                   // установить в 0
   else arr[ el + 1 ] |= sh;                         // установить в 1
}

bool get( data_t arr[], ulong pos ) {                // сосчитать состояние бита в битовом массиве
   ulong el = pos / size;
   data_t sh = (data_t)1 << ( pos % size );
   return 0 == ( arr[ el + 1 ] & sh );
}

void eratos( data_t *arr, ulong size ) {
   for( ulong i = 2; i * i <= size; i += i > 2 ? 2 : 1 ) // цикл от первого простого числа "2"
      if( 1 == get( arr, i ) ) 
         for( ulong j = i * i; j < size; j += i )        // вычеркивание всех чисел кратных i 
            set( arr, j, false );
}

int main( int argc, char **argv ) {
   long n;
   while( 1 ) {
      cout << "граничное число: ";
      cin >> n;
      data_t *a = new data_t[ n / size + 1 ];
      set( a, 0, false );
      set( a, 1, false );                          // вычёркиваем "0" и "1"
      for( ulong k = 2; k < n; k++ ) 
         set( a, k, true );                        // остальные размечаем как простые
      eratos( a, n );
      ulong j = 0;
      for( ulong k = 0; k < n; k++ )
         j += ( get( a, k ) != 0 ? 1 : 0 );
      cout << j << " простых чисел:" << endl;
      const int INLINE = 10;
      for( ulong k = 0, j = 0; k < n; k++ )
         if( get( a, k ) ) 
            printf( "%5lu%s", k, ( 0 == ++j % INLINE ? "\n" : "" ) );
      if( j % INLINE != 0 ) printf( "\n" );
      delete [] a;
   }
   return 0;
}
